//http main page
void MainPage(void) {
  // Authentication is required ?
  if (WWWAUTHENTI == true) {
    // request for www user/password from client
    if (!server.authenticate(WWWUSERNAME, WWWPASSWORD)) {
      return server.requestAuthentication();
    }
  }
  // website layout
  String buff  = "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
  buff += "<html><head><meta content=\"text/html; charset=utf-8\"><meta http-equiv=\"refresh\" content=\"" + String(PageRefreshPeriod) + "\">\n";
  buff += "<title>ESP8266 Humidity</title></head><body style=\"font-family:Arial,sans-serif\">\n";
  buff += "<table frame=\"box\" cellpadding=\"5\" style=\"text-align:left; Font-weight:bold; font-size:large; padding: 0; border-spacing: 0;\">\n";
  buff += "<tr style=\"background-color:#f0f0f0\"><td>NAME</td><td colspan=\"2\">" + String(SensorName) + "</td><td>" + String(Version) + "</td></tr>\n";
  buff += "<tr style=\"background-color:#ffffff\"><td>MAC</td><td colspan=\"2\">" + StrMacAddr + "</td><td></td></tr>\n";
  buff += "<tr style=\"background-color:#f0f0f0\"><td>VALUE</td><td colspan=\"2\">TEMPERATURE</td><td>" + String(temperature, FloatRounding) + " &deg;C</td></tr>\n";
  buff += "<tr style=\"background-color:#ffffff\"><td>VALUE</td><td colspan=\"2\">HUMIDITY</td><td>" + String(humidity, FloatRounding) + " %</td></tr>\n";
  buff += "<tr style=\"background-color:#f0f0f0\"><td>RESET</td><td colspan=\"2\">" + String(ResetReason) + "</td ><td></td></tr>\n";
  buff += "<tr style=\"background-color:#ffffff\"><td>ON</td><td colspan=\"2\">" + TimeString + "</td ><td></td></tr>\n";
  buff += "<tr style=\"background-color:#f0f0f0\"><td>WiFi</td><td colspan=\"2\">" + String(rssi) + " dBm</td><td>" + String(PercentRssi, 0) + " %</td ></tr>\n";
  buff += "<tr style=\"background-color:#ffffff\"><td>RAM</td><td colspan=\"2\">" + String(FreeHeap) + "</td><td>BYTE</td></tr>\n";
  buff += "<tr style=\"background-color:#f0f0f0\"><td>VCC</td><td colspan=\"2\">CHIP VOLTAGE</td><td>" + String(Vcc, 2) + " V</td></tr>\n";
  buff += "<tr style=\"background-color:#ffffff\"><td></td><td colspan=\"2\">" + message + "</td><td>" + SymbolRefresh + "</td></tr>\n";
  buff += "<tr style=\"background-color:#f0f0f0\"><td></td><td colspan=\"2\">" + response + "</td><td></td></tr>\n";
  buff += "</table>\n";
  buff += "</body></html>\n";
  server.send(200, "text/html", buff);
}
void GraficPage(void) {
  // Authentication is required ?
  if (WWWAUTHENTI == true) {
    // request for www user/password from client
    if (!server.authenticate(WWWUSERNAME, WWWPASSWORD)) {
      return server.requestAuthentication();
    }
  }
  String buff  = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"><html><head>\n";
  buff += "<meta http-equiv=\"refresh\" content=\"" + String(PageRefreshPeriod) + "\">\n";
  buff += "<style> img { width: 50%; height:auto; }</style>\n";
  buff += "<title>Hygrometer</title></head><body style=\"background:silver\">\n";
  buff += "<img src=\"hygro.svg\" alt=\"Hygrometer\">\n";
  buff += "<br></body></html>\n";
  server.send(200, "text/html", buff);
}
// SVG picture
void SvgPicture(void) {
  // Authentication is required ?
  if (WWWAUTHENTI == true) {
    // request for www user/password from client
    if (!server.authenticate(WWWUSERNAME, WWWPASSWORD)) {
      return server.requestAuthentication();
    }
  }
  String buff  = F("<svg xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" width=\"1000\" height=\"1000\">\n");
  buff += F("<circle cx=\"500\" cy=\"500\" r=\"265\" fill=\"WhiteSmoke\" stroke=\"#b46b41\" stroke-width=\"16\"/>\n");
  buff += F("<circle cx=\"500\" cy=\"500\" r=\"265\" fill-opacity=\"0\" stroke=\"#c68762\" stroke-width=\"4\"/>\n");
  buff += F("<g stroke=\"black\" stroke-width=\"2\" fill=\"none\">\n");
  buff += F("<rect x=\"450\" y=\"590\" rx=\"5\" ry=\"5\" width=\"100\" height=\"40\"/>\n");
  buff += F("<rect x=\"450\" y=\"635\" rx=\"5\" ry=\"5\" width=\"100\" height=\"40\"/></g>\n");
  buff += F("<path fill=\"none\" stroke=\"#2e8b57\" stroke-width=\"20\" d=\"M413,331 A190,190 35 0 1 657,393\" />\n");
  buff += F("<defs>\n");
  buff += F("<g id=\"PO\">\n");
  buff += F("<line stroke-width=\"5\" x1=\"500\" y1=\"500\" x2=\"500\" y2=\"700\" fill=\"orangered\"/>\n");
  buff += F("<rect x=\"492\" y=\"455\" rx=\"2\" ry=\"2\" width=\"16\" height=\"64\" fill=\"orangered\"/>\n");
  buff += F("<circle cx=\"500\" cy=\"500\" r=\"2\" stroke=\"brown\" stroke-width=\"4\" />\n");
  buff += F("<circle cx=\"500\" cy=\"500\" r=\"3\" fill=\"grey\"/></g>\n");
  buff += F("<g>\n");
  buff += F("<line stroke-width=\"4\" id=\"M\" x1=\"500\" y1=\"680\" x2=\"500\" y2=\"700\"/>\n");
  buff += F("<line stroke-width=\"6\" id=\"L\" x1=\"500\" y1=\"670\" x2=\"500\" y2=\"700\"/></g>\n");
  buff += F("<g id=\"Z\">\n");
  buff += F("<use xlink:href=\"#L\" transform=\"rotate(0,500,500)\"/>\n");
  buff += F("<use xlink:href=\"#M\" transform=\"rotate(14,500,500)\"/></g></defs>\n");
  buff += F("<g id=\"T\" stroke=\"black\">\n");
  buff += F("<use xlink:href=\"#Z\" transform=\"rotate(40,500,500)\"/>\n");
  buff += F("<use xlink:href=\"#Z\" transform=\"rotate(68,500,500)\"/>\n");
  buff += F("<use xlink:href=\"#Z\" transform=\"rotate(96,500,500)\"/>\n");
  buff += F("<use xlink:href=\"#Z\" transform=\"rotate(124,500,500)\"/>\n");
  buff += F("<use xlink:href=\"#Z\" transform=\"rotate(152,500,500)\"/>\n");
  buff += F("<use xlink:href=\"#Z\" transform=\"rotate(180,500,500)\"/>\n");
  buff += F("<use xlink:href=\"#Z\" transform=\"rotate(208,500,500)\"/>\n");
  buff += F("<use xlink:href=\"#Z\" transform=\"rotate(236,500,500)\"/>\n");
  buff += F("<use xlink:href=\"#Z\" transform=\"rotate(264,500,500)\"/>\n");
  buff += F("<use xlink:href=\"#Z\" transform=\"rotate(292,500,500)\"/>\n");
  buff += F("<use xlink:href=\"#L\" transform=\"rotate(320,500,500)\"/></g>\n");
  buff += F("<g font-family=\"arial\" font-size=\"36\" font-weight=\"normal\" font-style=\"normal\" stroke=\"black\" fill=\"black\" >\n");
  buff += F("<text x=\"350\" y=\"685\">0</text>\n");
  buff += F("<text x=\"270\" y=\"590\">10</text>\n");
  buff += F("<text x=\"255\" y=\"490\">20</text>\n");
  buff += F("<text x=\"290\" y=\"395\">30</text>\n");
  buff += F("<text x=\"378\" y=\"315\">40</text>\n");
  buff += F("<text x=\"480\" y=\"295\">50</text>\n");
  buff += F("<text x=\"577\" y=\"316\">60</text>\n");
  buff += F("<text x=\"660\" y=\"380\">70</text>\n");
  buff += F("<text x=\"705\" y=\"490\">80</text>\n");
  buff += F("<text x=\"690\" y=\"595\">90</text>\n");
  buff += F("<text x=\"610\" y=\"690\">100</text>\n");
  buff += F("<text x=\"450\" y=\"720\">% RH</text>\n");
  buff += "<text x=\"465\" y=\"623\" fill=\"brown\">" + String(temperature, FloatRounding) + "</text>\n";
  buff += F("<text x=\"560\" y=\"620\" font-size=\"28\">C</text>\n");
  buff += "<text x=\"465\" y=\"668\" fill=\"blue\">" + String(humidity, FloatRounding) + "</text>\n";
  buff += F("<circle cx=\"560\" cy=\"595\" r=\"3\" fill=\"white\" stroke=\"black\" stroke-width=\"2\"/></g>\n");
  buff += F("<g stroke=\"red\" stroke-width=\"1\" fill=\"none\">\n");
  buff += "<use xlink:href=\"#PO\" transform=\"rotate(" + String(PointerAngle) + ",500,500)\"/></g></svg>\n";
  server.send(200, "image/svg+xml", buff);
};

// page not found service
void FileNotFound(void) {
  server.send(404, "text/plain", "Page not found !");
}
